import { __decorate, __extends, __values } from 'tslib';
import { ɵɵdefineInjectable, Injectable, Input, TemplateRef, ViewContainerRef, Directive, ElementRef, Injector, HostBinding, ViewChild, ContentChildren, Component, EventEmitter, Output, HostListener, forwardRef, NgModule } from '@angular/core';
import { NgControl, NgModel, NG_VALUE_ACCESSOR, NG_VALIDATORS, NgForm, FormControlName, FormsModule, ReactiveFormsModule } from '@angular/forms';
import 'reflect-metadata';
import { CommonModule } from '@angular/common';
import { TranslateModule } from '@ngx-translate/core';

var NgxValidatorService = /** @class */ (function () {
    function NgxValidatorService() {
    }
    NgxValidatorService.ɵprov = ɵɵdefineInjectable({ factory: function NgxValidatorService_Factory() { return new NgxValidatorService(); }, token: NgxValidatorService, providedIn: "root" });
    NgxValidatorService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], NgxValidatorService);
    return NgxValidatorService;
}());

var DataTypeEnum;
(function (DataTypeEnum) {
    DataTypeEnum[DataTypeEnum["Int"] = 0] = "Int";
    DataTypeEnum[DataTypeEnum["Number"] = 1] = "Number";
    DataTypeEnum[DataTypeEnum["MultilineText"] = 2] = "MultilineText";
    DataTypeEnum[DataTypeEnum["Url"] = 3] = "Url";
    DataTypeEnum[DataTypeEnum["ImageUrl"] = 4] = "ImageUrl";
    DataTypeEnum[DataTypeEnum["Password"] = 5] = "Password";
    DataTypeEnum[DataTypeEnum["Hexadecimal"] = 6] = "Hexadecimal";
    DataTypeEnum[DataTypeEnum["Date"] = 7] = "Date";
    DataTypeEnum[DataTypeEnum["Array"] = 8] = "Array";
    DataTypeEnum[DataTypeEnum["Upload"] = 9] = "Upload";
})(DataTypeEnum || (DataTypeEnum = {}));

function isEmpty(obj) {
    for (var key in obj) {
        if (obj.hasOwnProperty(key)) {
            return false;
        }
    }
    return true;
}
// tslint:disable-next-line:callable-types
function ModelState(constructor) {
    return /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * Returns model validation state
         */
        class_1.prototype.IsValid = function () {
            var e_1, _a, e_2, _b;
            try {
                for (var _c = __values(Reflect.getMetadataKeys(this)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var item = _d.value;
                    var attribs = getDecorators(this, item);
                    try {
                        for (var _e = (e_2 = void 0, __values(attribs.filter(function (x) { return x.key !== 'ReadOnly' && x.key !== 'NoForm'; }))), _f = _e.next(); !_f.done; _f = _e.next()) {
                            var attrib = _f.value;
                            var messg = ngxValidate(attrib.key, attrib.value, this[item], this);
                            if (messg) {
                                return false;
                            }
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return true;
        };
        /**
         * Placeholder(string)
         * Validate: function
         */
        class_1.prototype.ModelErrors = function () {
            var e_3, _a, e_4, _b;
            var errs = {};
            var tmp = {};
            try {
                for (var _c = __values(Reflect.getMetadataKeys(this)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var item = _d.value;
                    var attribs = getDecorators(this, item);
                    try {
                        for (var _e = (e_4 = void 0, __values(attribs.filter(function (x) { return x.key !== 'ReadOnly' && x.key !== 'NoForm'; }))), _f = _e.next(); !_f.done; _f = _e.next()) {
                            var attrib = _f.value;
                            var messg = ngxValidate(attrib.key, attrib.value, this[item], this);
                            if (messg) {
                                tmp[attrib.key] = messg;
                            }
                        }
                    }
                    catch (e_4_1) { e_4 = { error: e_4_1 }; }
                    finally {
                        try {
                            if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                        }
                        finally { if (e_4) throw e_4.error; }
                    }
                    if (!isEmpty(tmp)) {
                        errs[item] = tmp;
                    }
                    tmp = {};
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_3) throw e_3.error; }
            }
            return errs;
        };
        return class_1;
    }(constructor));
}
/**
 * Validates field if it has valid value according to value parameter
 */
function DataType(param) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:DataType', param, target, propertyKey);
    };
}
/**
 * Validates field if it represents valid credit card number
 */
function CreditCard(param) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:CreditCard', param, target, propertyKey);
    };
}
/**
 * Compares field to other field and checks if they are equal
 */
function Compare(param) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:Compare', param, target, propertyKey);
    };
}
/**
 * Validates if field value contains specific value
 */
function Contains(param) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:Contains', param, target, propertyKey);
    };
}
/**
 * Validates field according to custom logic
 */
function Custom(param) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:Custom', param, target, propertyKey);
    };
}
/**
 * Sets the name metadata for the field
 */
function Name(param) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:Name', param, target, propertyKey);
    };
}
/**
 * Validates field and checks if it has null, undefined or empty value
 */
function Required(param) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:Required', param, target, propertyKey);
    };
}
/**
 * Validates field if other field has specific value and checks if it has null, undefined or empty value
 */
function RequiredIf(param) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:RequiredIf', param, target, propertyKey);
    };
}
/**
 * Sets field's input value to readonly
 */
function ReadOnly() {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, propertyKey, target);
        Reflect.defineMetadata('custom-reflect:ReadOnly', null, target, propertyKey);
    };
}
/**
 * Validates if field has valid value according to specified pattern
 */
function Pattern(param) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:Pattern', param, target, propertyKey);
    };
}
/**
 * Validates if field has valid value more than specific value
 */
function MinValue(input) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, input, target);
        Reflect.defineMetadata('custom-reflect:MinValue', input, target, propertyKey);
    };
}
/**
 * Validates if field has valid value less than specific value
 */
function MaxValue(input) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, input, target);
        Reflect.defineMetadata('custom-reflect:MaxValue', input, target, propertyKey);
    };
}
/**
 * Validates if field value does not contain specific value
 */
function NotContains(param) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:NotContains', param, target, propertyKey);
    };
}
/**
 * Tells form generator component not to generate input for this field
 */
function NoForm() {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, propertyKey, target);
        Reflect.defineMetadata('custom-reflect:NoForm', null, target, propertyKey);
    };
}
/**
 * Validates if field value length fits in min and max values
 */
function StringLength(input) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, input, target);
        Reflect.defineMetadata('custom-reflect:StringLength', input, target, propertyKey);
    };
}
/**
 * Validates if field value is valid email value
 */
function Email(input) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, input, target);
        Reflect.defineMetadata('custom-reflect:Email', input, target, propertyKey);
    };
}
/**
 * Sets placeholder value for field input
 */
function Placeholder(input) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, input, target);
        Reflect.defineMetadata('custom-reflect:Placeholder', input, target, propertyKey);
    };
}
/**
 * Validates if field value length fits in min and max values
 */
function Range(input) {
    return function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, input, target);
        Reflect.defineMetadata('custom-reflect:Range', input, target, propertyKey);
    };
}
function configurable(value) {
    return function (target, propertyKey, descriptor) {
        descriptor.configurable = value;
    };
}
/**
 * Placeholder(string)
 * Validate: function
 */
function getDecorators(target, propertyName) {
    var keys = Reflect.getMetadataKeys(target, propertyName);
    var decorators = keys.filter(function (key) { return key.toString().startsWith('custom-reflect:'); })
        .reduce(function (values, key) {
        var value = Reflect.getMetadata(key, target, propertyName);
        return values.concat({ key: key.toString().replace('custom-reflect:', ''), value: value });
    }, []);
    return decorators;
}
function ngxValidate(key, param, value, dataModel) {
    var retstr;
    if ((value === null || value === undefined || value === '') && key !== 'Required' && key !== 'RequiredIf'
        && key !== 'Compare' && key !== 'Range') {
        return null;
    }
    var errorString = '';
    if (typeof param === 'string') {
        errorString = param;
    }
    else {
        errorString = param.error;
    }
    if (!errorString) {
        errorString = 'error not asigned!';
    }
    switch (key) {
        case 'CreditCard': {
            value = value.replace(/[- ]+/g, '');
            var Visa = /^4[0-9]{12}(?:[0-9]{3})?$/;
            var MasterCard = /^(?:5[1-5][0-9]{2}|222[1-9]|22[3-9][0-9]|2[3-6][0-9]{2}|27[01][0-9]|2720)[0-9]{12}$/;
            var Amex = /^3[47][0-9]{13}$/;
            var DinersClub = /^3(?:0[0-5]|[68][0-9])[0-9]{11}$/;
            var Discover = /^6(?:011|5[0-9]{2})[0-9]{12}$/;
            var JCB = /^(?:2131|1800|35\d{3})\d{11}$/;
            var BCGlobal = /^(6541|6556)[0-9]{12}$/;
            var CarteBlanche = /^389[0-9]{11}$/;
            var InstaPayment = /^63[7-9][0-9]{13}$/;
            var KoreanLocalCard = /^9[0-9]{15}$/;
            var Laser = /^(6304|6706|6709|6771)[0-9]{12,15}$/;
            var Maestro = /^(5018|5020|5038|6304|6759|6761|6763)[0-9]{8,15}$/;
            var Solo = /^(6334|6767)[0-9]{12}|(6334|6767)[0-9]{14}|(6334|6767)[0-9]{15}$/;
            // tslint:disable-next-line:max-line-length
            var Switch = /^(4903|4905|4911|4936|6333|6759)[0-9]{12}|(4903|4905|4911|4936|6333|6759)[0-9]{14}|(4903|4905|4911|4936|6333|6759)[0-9]{15}|564182[0-9]{10}|564182[0-9]{12}|564182[0-9]{13}|633110[0-9]{10}|633110[0-9]{12}|633110[0-9]{13}$/;
            var UnionPay = /^(62[0-9]{14,17})$/;
            if (!checkLuhn(value) ||
                !(Visa.test(value) || MasterCard.test(value) || Amex.test(value) || DinersClub.test(value)
                    || Discover.test(value) || JCB.test(value) || BCGlobal.test(value) || CarteBlanche.test(value)
                    || InstaPayment.test(value) || KoreanLocalCard.test(value) || Laser.test(value)
                    || Maestro.test(value) || Solo.test(value) || Switch.test(value) || UnionPay.test(value) ||
                    (param.customValue && param.customValue.test(value)))) {
                retstr = param.error;
            }
            break;
        }
        case 'Compare': {
            if (value !== dataModel[param.field]) {
                retstr = errorString;
            }
            break;
        }
        case 'Contains': {
            if (value.indexOf(param.value) === -1) {
                retstr = errorString;
            }
            break;
        }
        case 'Custom': {
            var result = param.customFunc(value, dataModel);
            if (!result) {
                retstr = errorString;
            }
            break;
        }
        case 'DataType': {
            if (param.value === DataTypeEnum.Number) {
                var reg = /^[+-]?\d+(\.\d+)?$/;
                if (isNaN(parseFloat(value)) || !reg.test(value)) {
                    retstr = errorString;
                }
            }
            if (param.value === DataTypeEnum.Date) {
                if (!(value instanceof Date)) {
                    retstr = errorString;
                }
            }
            if (param.value === DataTypeEnum.Hexadecimal) {
                var expression = /^([0-9a-fA-F]+)$/i;
                if (!expression.test(value)) {
                    retstr = errorString;
                }
            }
            if (param.value === DataTypeEnum.Int) {
                var reg = /^[+\-]?\d+$/;
                if (isNaN(parseFloat(value))
                    || !isNaN(parseFloat(value)) && (parseFloat(value) - parseInt(value, 10) !== 0)
                    || !reg.test(value)) {
                    retstr = errorString;
                }
            }
            if (param.value === DataTypeEnum.Array) {
                if (!Array.isArray(value)) {
                    retstr = errorString;
                }
            }
            break;
        }
        case 'NotContains': {
            if (value.indexOf(param.value) !== -1) {
                retstr = errorString;
            }
            break;
        }
        case 'Required': {
            if (value === null || value === undefined || value === '') {
                retstr = errorString;
            }
            break;
        }
        case 'RequiredIf': {
            if (!param.field || !param.value) {
                console.warn('incorrect parameters in RequiredIf attribute');
            }
            else {
                if ((param.value === dataModel[param.field])
                    && (value === null || value === undefined || value === '')) {
                    retstr = errorString;
                }
            }
            break;
        }
        case 'Pattern': {
            var pat = param.value;
            if (!pat.test(value)) {
                retstr = errorString;
            }
            break;
        }
        case 'MinValue': {
            if (value < param.value) {
                retstr = errorString.replace('{0}', param.value.toString());
            }
            break;
        }
        case 'MaxValue': {
            if (value > param.value) {
                retstr = errorString.replace('{0}', param.value.toString());
            }
            break;
        }
        case 'StringLength': {
            if (!value || value.length < param.min || value.length > param.max) {
                retstr = errorString.replace('{0}', param.min
                    .toString())
                    .replace('{1}', param.max.toString());
            }
            break;
        }
        case 'Range': {
            if (value < param.min || value > param.max) {
                retstr = errorString.replace('{0}', param.min
                    .toString())
                    .replace('{1}', param.max.toString());
            }
            break;
        }
        case 'Email': {
            // credits http://emailregex.com/
            // tslint:disable-next-line:max-line-length
            var emreg = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
            if (!emreg.test(value)) {
                retstr = errorString;
            }
            break;
        }
        default: {
            retstr = null;
            break;
        }
    }
    return retstr;
}
function checkLuhn(value) {
    // credits https://github.com/JamesEggers1/node-luhn
    var trimmed = String(value).replace(/[\s]/g, '');
    var length = trimmed.length;
    var odd = false;
    var total = 0;
    var calc;
    var calc2;
    if (length === 0) {
        return true;
    }
    if (!/^[0-9]+$/.test(trimmed)) {
        return false;
    }
    for (var i = length; i > 0; i--) {
        calc = parseInt(trimmed.charAt(i - 1), 10);
        if (!odd) {
            total += calc;
        }
        else {
            calc2 = calc * 2;
            switch (calc2) {
                case 10:
                    calc2 = 1;
                    break;
                case 12:
                    calc2 = 3;
                    break;
                case 14:
                    calc2 = 5;
                    break;
                case 16:
                    calc2 = 7;
                    break;
                case 18:
                    calc2 = 9;
                    break;
                default: calc2 = calc2;
            }
            total += calc2;
        }
        odd = !odd;
    }
    return (total !== 0 && (total % 10) === 0);
}

// credits to https://github.com/clbond/form-example
var ValueAccessorBase = /** @class */ (function () {
    function ValueAccessorBase(theInjector) {
        this.theInjector = theInjector;
        this.onChange = null;
        this.onTouch = null;
    }
    Object.defineProperty(ValueAccessorBase.prototype, "formControl", {
        get: function () {
            if (this.control != null) {
                return this.control;
            }
            this.control = this.theInjector.get(NgControl, null);
            return this.control;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ValueAccessorBase.prototype, "value", {
        get: function () {
            return this.innerValue;
        },
        set: function (value) {
            if (this.innerValue !== value) {
                this.innerValue = value;
                if (this.onChange) {
                    this.onChange(value);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    ValueAccessorBase.prototype.writeValue = function (value) {
        this.innerValue = value;
        if (this.onChange) {
            this.onChange(value);
        }
    };
    ValueAccessorBase.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    ValueAccessorBase.prototype.registerOnTouched = function (fn) {
        this.onTouch = fn;
    };
    ValueAccessorBase.prototype.setDisabledState = function (disabled) {
        this.disabled = disabled;
    };
    ValueAccessorBase.prototype.touch = function () {
        if (this.onTouch) {
            this.onTouch();
        }
    };
    return ValueAccessorBase;
}());

function validateControl(control, dataModel) {
    var e_1, _a, e_2, _b;
    var name;
    if (control.parent) {
        try {
            for (var _c = __values(Object.keys(control.parent.controls)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var item = _d.value;
                if (control.parent.controls[item] === control) {
                    name = item;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }
    else {
        name = this.field;
    }
    var attribs = getDecorators(dataModel, name);
    var errs = {};
    if (attribs.find(function (x) { return x.key === 'ReadOnly'; })) {
        this.el.nativeElement.setAttribute('readonly', true);
    }
    try {
        for (var _e = __values(attribs.filter(function (x) { return x.key !== 'ReadOnly' && x.key !== 'NoForm'; })), _f = _e.next(); !_f.done; _f = _e.next()) {
            var item = _f.value;
            var messg = ngxValidate(item.key, item.value, control.value, dataModel);
            if (messg) {
                errs[item.key] = messg;
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
        }
        finally { if (e_2) throw e_2.error; }
    }
    return errs;
}

var ElementBase = /** @class */ (function (_super) {
    __extends(ElementBase, _super);
    function ElementBase(injector) {
        var _this = _super.call(this, injector) || this;
        _this.injector = injector;
        _this.validator = validateControl;
        return _this;
    }
    ElementBase.prototype.validate = function (control) {
        return this.validator(control, this.model);
    };
    __decorate([
        Input()
    ], ElementBase.prototype, "model", void 0);
    return ElementBase;
}(ValueAccessorBase));

var NgxCustomTemplateForDirective = /** @class */ (function () {
    function NgxCustomTemplateForDirective(templateRef, viewContainer) {
        this.templateRef = templateRef;
        this.viewContainer = viewContainer;
    }
    NgxCustomTemplateForDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef }
    ]; };
    __decorate([
        Input()
    ], NgxCustomTemplateForDirective.prototype, "ngxCustomTemplateFor", void 0);
    NgxCustomTemplateForDirective = __decorate([
        Directive({
            // tslint:disable-next-line:directive-selector
            selector: '[ngxCustomTemplateFor]'
        })
    ], NgxCustomTemplateForDirective);
    return NgxCustomTemplateForDirective;
}());

var NgxDropdownForComponent = /** @class */ (function (_super) {
    __extends(NgxDropdownForComponent, _super);
    function NgxDropdownForComponent(el, injector) {
        var _this = _super.call(this, injector) || this;
        _this.el = el;
        _this.injector = injector;
        _this.DataTypeEnum = DataTypeEnum;
        _this.placeHolder = '';
        _this.name = '';
        _this.readonly = false;
        _this.ngxDropdown = true;
        _this.itemSource = [];
        _this.valuePrimitive = true;
        _this.defaultItem = true;
        return _this;
    }
    NgxDropdownForComponent_1 = NgxDropdownForComponent;
    Object.defineProperty(NgxDropdownForComponent.prototype, "templates", {
        set: function (value) {
            var _this = this;
            if (this.model) {
                value.forEach(function (item) {
                    _this.template = item;
                });
            }
        },
        enumerable: true,
        configurable: true
    });
    NgxDropdownForComponent.prototype.ngOnInit = function () {
        if (!this.model) {
            console.error('ngx-validator error! [model] property is not binded!');
        }
        if (this.field === null || this.field === undefined) {
            this.field = this.el.nativeElement.getAttribute('name') === null
                ? this.el.nativeElement.getAttribute('id')
                : this.el.nativeElement.getAttribute('name');
        }
        if (!this.field) {
            this.field = this.el.nativeElement.getAttribute('formControlName');
        }
        var attribs = getDecorators(this.model, this.field);
        if (attribs.find(function (x) { return x.key === 'Placeholder'; })) {
            this.placeHolder = attribs.find(function (x) { return x.key === 'Placeholder'; }).value;
        }
        if (attribs.find(function (x) { return x.key === 'ReadOnly'; })) {
            this.readonly = true;
        }
        if (attribs.find(function (x) { return x.key === 'Name'; })) {
            this.name = attribs.find(function (x) { return x.key === 'Name'; }).value;
        }
        else {
            this.name = this.field;
        }
    };
    var NgxDropdownForComponent_1;
    NgxDropdownForComponent.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Injector }
    ]; };
    __decorate([
        HostBinding('class.ngx-dropdown')
    ], NgxDropdownForComponent.prototype, "ngxDropdown", void 0);
    __decorate([
        Input()
    ], NgxDropdownForComponent.prototype, "itemSource", void 0);
    __decorate([
        Input()
    ], NgxDropdownForComponent.prototype, "field", void 0);
    __decorate([
        Input()
    ], NgxDropdownForComponent.prototype, "key", void 0);
    __decorate([
        Input()
    ], NgxDropdownForComponent.prototype, "valuePrimitive", void 0);
    __decorate([
        Input()
    ], NgxDropdownForComponent.prototype, "text", void 0);
    __decorate([
        ViewChild(NgModel, { static: false })
    ], NgxDropdownForComponent.prototype, "ngModel", void 0);
    __decorate([
        Input()
    ], NgxDropdownForComponent.prototype, "defaultItem", void 0);
    __decorate([
        ContentChildren(NgxCustomTemplateForDirective, { descendants: false })
    ], NgxDropdownForComponent.prototype, "templates", null);
    NgxDropdownForComponent = NgxDropdownForComponent_1 = __decorate([
        Component({
            // tslint:disable-next-line:component-selector
            selector: 'ngx-dropdown-for',
            template: "<select\n    [(ngModel)]=\"value\"\n    [ngStyle]=\"{'color':'red'}\"\n    class=\"ngx-dropdown-child\">\n    <option\n        value=\"undefined\"\n        disabled\n        class=\"ngx-dropdown-child-default\"\n        selected\n        hidden\n        *ngIf=\"defaultItem\">\n        {{placeHolder}}\n    </option>\n    <ng-container *ngIf=\"valuePrimitive; else nonPrimitve\">\n        <option\n            *ngFor=\"let item of itemSource\"\n            [ngValue]=\"item[key]\">\n            {{item[text]}}\n        </option>\n    </ng-container>\n    <ng-template #nonPrimitve>\n        <option\n            *ngFor=\"let item of itemSource\"\n            [ngValue]=\"item\">\n            {{item[text]}}\n        </option>\n    </ng-template>\n</select>\n",
            providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: NgxDropdownForComponent_1, multi: true },
                { provide: NG_VALIDATORS, useExisting: NgxDropdownForComponent_1, multi: true }
            ]
        })
    ], NgxDropdownForComponent);
    return NgxDropdownForComponent;
}(ElementBase));

var NgxFormForReactiveComponent = /** @class */ (function () {
    function NgxFormForReactiveComponent() {
        this.propertyNames = [];
        this.submitForm = new EventEmitter();
        // tslint:disable-next-line:variable-name
        this._templates = [];
    }
    Object.defineProperty(NgxFormForReactiveComponent.prototype, "model", {
        set: function (value) {
            this._model = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxFormForReactiveComponent.prototype, "formGroup", {
        set: function (value) {
            var e_1, _a;
            this._formGroup = value;
            try {
                for (var _b = __values(Object.keys(this._model)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var item = _c.value;
                    var attribs = getDecorators(this._model, item);
                    if (!attribs.find(function (x) { return x.key === 'NoForm'; }) && this._formGroup.controls[item]) {
                        this.propertyNames.push({ field: item, template: false });
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxFormForReactiveComponent.prototype, "templates", {
        set: function (value) {
            var _this = this;
            if (this._model) {
                value.forEach(function (item) {
                    if (_this.propertyNames.find(function (x) { return x.field === item.ngxCustomTemplateFor; })) {
                        _this._templates.push(item);
                        _this.propertyNames.find(function (x) { return x.field === item.ngxCustomTemplateFor; }).template = true;
                    }
                    else {
                        throw (new Error("Property name bound on NgxCustomTemplateForDirective " + item.ngxCustomTemplateFor + " not found.\n           If it is definity correct, please check if you have initialized it before passing model to ngx-form-for component"));
                    }
                });
            }
        },
        enumerable: true,
        configurable: true
    });
    NgxFormForReactiveComponent.prototype.ngOnInit = function () {
    };
    NgxFormForReactiveComponent.prototype.getTemplate = function (field) {
        return this._templates.find(function (x) { return x.ngxCustomTemplateFor === field; }).templateRef;
    };
    NgxFormForReactiveComponent.prototype.submit = function () {
        this.submitForm.emit(this._model);
    };
    NgxFormForReactiveComponent.prototype.controlExists = function (item) {
        if (this.formGroup.controls[item]) {
            return true;
        }
        else {
            return false;
        }
    };
    __decorate([
        Input()
    ], NgxFormForReactiveComponent.prototype, "cssClasses", void 0);
    __decorate([
        Input()
    ], NgxFormForReactiveComponent.prototype, "model", null);
    __decorate([
        Input()
    ], NgxFormForReactiveComponent.prototype, "formGroup", null);
    __decorate([
        Input()
    ], NgxFormForReactiveComponent.prototype, "autoComplete", void 0);
    __decorate([
        ViewChild(NgForm, { static: false })
    ], NgxFormForReactiveComponent.prototype, "form", void 0);
    __decorate([
        Output()
    ], NgxFormForReactiveComponent.prototype, "submitForm", void 0);
    __decorate([
        ContentChildren(NgxCustomTemplateForDirective, { descendants: false })
    ], NgxFormForReactiveComponent.prototype, "templates", null);
    NgxFormForReactiveComponent = __decorate([
        Component({
            // tslint:disable-next-line:component-selector
            selector: 'ngx-form-for-reactive',
            template: "<form\n    #form=\"ngForm\"\n    (ngSubmit)=\"submit()\"\n    [autocomplete]=\"autoComplete\"\n    [formGroup]=\"_formGroup\">\n    <div\n        [ngClass]=\"cssClasses? cssClasses.group: 'ngx-form-for'\"\n        *ngFor=\"let item of propertyNames\">\n        <ng-container *ngIf=\"!item.template; else template\">\n            <ngx-label-for\n                [model]=\"_model\"\n                [field]=\"item.field\"\n                [ngClass]=\"cssClasses? cssClasses.label:''\"></ngx-label-for>\n            <ngx-input-for\n                [formControlName]=\"item.field\"\n                [model]=\"_model\"\n                [ngClass]=\"cssClasses? cssClasses.input:''\"></ngx-input-for>\n            <ngx-validator-for\n                [errors]=\"_formGroup.get(item.field)?.errors\"\n                [ngClass]=\"cssClasses? cssClasses.error: ''\">\n            </ngx-validator-for>\n        </ng-container>\n        <ng-template #template>\n            <!-- temporary form validation workaround. custom temlpate is not binded to form's controls and therefore, form validation doesn't work. help needed -->\n            <input\n                [formControlName]=\"item.field\"\n                [ngx-validator]=\"_model\"\n                style=\"display:none\">\n            <ng-container\n                [ngTemplateOutlet]=\"getTemplate(item.field)\"\n                [ngTemplateOutletContext]=\"{$implicit: {model: _model, form: form}}\">\n            </ng-container>\n        </ng-template>\n    </div>\n    <button\n        type=\"submit\"\n        [disabled]=\"form.invalid\"\n        class=\"btn btn-success\">\n        Submit\n    </button>\n</form>\n"
        })
    ], NgxFormForReactiveComponent);
    return NgxFormForReactiveComponent;
}());

var NgxFormForComponent = /** @class */ (function () {
    function NgxFormForComponent() {
        this.propertyNames = [];
        this.submitForm = new EventEmitter();
        // tslint:disable-next-line:variable-name
        this._templates = [];
    }
    Object.defineProperty(NgxFormForComponent.prototype, "model", {
        set: function (value) {
            var e_1, _a, e_2, _b;
            this._model = value;
            try {
                for (var _c = __values(Object.keys(this._model)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var item = _d.value;
                    var attribs = getDecorators(this._model, item);
                    if (!attribs.find(function (x) { return x.key === 'NoForm'; })) {
                        this.propertyNames.push({ field: item, template: false });
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_1) throw e_1.error; }
            }
            var _loop_1 = function (item) {
                var attribs = getDecorators(this_1._model, item);
                if (!attribs.find(function (x) { return x.key === 'NoForm'; }) && this_1.propertyNames.find(function (x) { return x.field === item; }) === undefined) {
                    this_1.propertyNames.push({ field: item, template: false });
                }
            };
            var this_1 = this;
            try {
                for (var _e = __values(Reflect.getMetadataKeys(this._model)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var item = _f.value;
                    _loop_1(item);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                }
                finally { if (e_2) throw e_2.error; }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxFormForComponent.prototype, "templates", {
        set: function (value) {
            var _this = this;
            if (this._model) {
                value.forEach(function (item) {
                    if (_this.propertyNames.find(function (x) { return x.field === item.ngxCustomTemplateFor; })) {
                        _this._templates.push(item);
                        _this.propertyNames.find(function (x) { return x.field === item.ngxCustomTemplateFor; }).template = true;
                    }
                    else {
                        throw (new Error("Property name bound on NgxCustomTemplateForDirective " + item.ngxCustomTemplateFor + " not found.\n           If it is definity correct, please check if you have initialized it before passing model to ngx-form-for component"));
                    }
                });
            }
        },
        enumerable: true,
        configurable: true
    });
    NgxFormForComponent.prototype.ngOnInit = function () {
    };
    NgxFormForComponent.prototype.getTemplate = function (field) {
        return this._templates.find(function (x) { return x.ngxCustomTemplateFor === field; }).templateRef;
    };
    NgxFormForComponent.prototype.submit = function () {
        this.submitForm.emit(this._model);
    };
    __decorate([
        Input()
    ], NgxFormForComponent.prototype, "model", null);
    __decorate([
        Input()
    ], NgxFormForComponent.prototype, "cssClasses", void 0);
    __decorate([
        Input()
    ], NgxFormForComponent.prototype, "autoComplete", void 0);
    __decorate([
        ViewChild(NgForm, { static: false })
    ], NgxFormForComponent.prototype, "form", void 0);
    __decorate([
        Output()
    ], NgxFormForComponent.prototype, "submitForm", void 0);
    __decorate([
        ContentChildren(NgxCustomTemplateForDirective, { descendants: false })
    ], NgxFormForComponent.prototype, "templates", null);
    NgxFormForComponent = __decorate([
        Component({
            // tslint:disable-next-line:component-selector
            selector: 'ngx-form-for',
            template: "<form\n    #form=\"ngForm\"\n    (ngSubmit)=\"submit()\"\n    [autocomplete]=\"autoComplete\">\n    <div\n        [ngClass]=\"cssClasses?.group? cssClasses.group : 'ngx-form-for'\"\n        *ngFor=\"let item of propertyNames\">\n        <ng-container *ngIf=\"!item.template; else template\">\n            <ngx-label-for\n                [model]=\"_model\"\n                [field]=\"item.field\"\n                [ngClass]=\"cssClasses?.label ? cssClasses?.label: ''\"></ngx-label-for>\n            <ngx-input-for\n                [id]=\"item.field\"\n                [model]=\"_model\"\n                [(ngModel)]=\"_model[item.field]\"\n                [ngModelOptions]=\"{ name: item.field }\"\n                [field]=\"item.field\"\n                [ngClass]=\"cssClasses?.input ? cssClasses.input: ''\"></ngx-input-for>\n            <ngx-validator-for\n                [errors]=\"form.controls[item.field]?.errors\"\n                [ngClass]=\"cssClasses?.error ? cssClasses.error: ''\">\n            </ngx-validator-for>\n        </ng-container>\n        <ng-template #template>\n            <!-- temporary form validation workaround. custom temlpate is not binded to form's controls and therefore, form validation doesn't work. help needed -->\n            <input\n                [name]=\"item.field\"\n                [(ngModel)]=\"_model[item.field]\"\n                [ngx-validator]=\"_model\"\n                style=\"display:none\">\n            <ng-container\n                [ngTemplateOutlet]=\"getTemplate(item.field)\"\n                [ngTemplateOutletContext]=\"{$implicit: {model: _model, form: form}}\">\n            </ng-container>\n        </ng-template>\n    </div>\n    <button\n        type=\"submit\"\n        [disabled]=\"form.invalid\"\n        class=\"btn btn-success\">\n        Submit\n    </button>\n</form>\n"
        })
    ], NgxFormForComponent);
    return NgxFormForComponent;
}());

var NgxInputForComponent = /** @class */ (function (_super) {
    __extends(NgxInputForComponent, _super);
    function NgxInputForComponent(el, injector) {
        var _this = _super.call(this, injector) || this;
        _this.el = el;
        _this.injector = injector;
        _this.DataTypeEnum = DataTypeEnum;
        _this.placeHolder = '';
        _this.name = '';
        _this.blurEvent = new EventEmitter();
        _this.readonly = false;
        _this.ngxInput = true;
        return _this;
    }
    NgxInputForComponent_1 = NgxInputForComponent;
    NgxInputForComponent.prototype.onFocusout = function () {
        this.blurEvent.emit();
    };
    Object.defineProperty(NgxInputForComponent.prototype, "templates", {
        set: function (value) {
            var _this = this;
            if (this.model) {
                value.forEach(function (item) {
                    _this._template = item;
                });
            }
        },
        enumerable: true,
        configurable: true
    });
    NgxInputForComponent.prototype.ngOnInit = function () {
        if (!this.model) {
            console.error('ngx-validator error! [model] property is not binded!');
        }
        if (this.field === null || this.field === undefined) {
            this.field = this.el.nativeElement.getAttribute('name') === null
                ? this.el.nativeElement.getAttribute('id')
                : this.el.nativeElement.getAttribute('name');
        }
        if (!this.field) {
            this.field = this.el.nativeElement.getAttribute('formControlName');
        }
        this.autocomplete = this.el.nativeElement.getAttribute('autocomplete');
        var attribs = getDecorators(this.model, this.field);
        if (attribs.find(function (x) { return x.key === 'DataType'; })) {
            this.dataType = attribs.find(function (x) { return x.key === 'DataType'; }).value.value;
        }
        if (attribs.find(function (x) { return x.key === 'Placeholder'; })) {
            this.placeHolder = attribs.find(function (x) { return x.key === 'Placeholder'; }).value;
        }
        if (attribs.find(function (x) { return x.key === 'ReadOnly'; })) {
            this.readonly = true;
        }
        if (attribs.find(function (x) { return x.key === 'Name'; })) {
            this.name = attribs.find(function (x) { return x.key === 'Name'; }).value;
        }
        else {
            this.name = this.field;
        }
    };
    NgxInputForComponent.prototype.getTemplate = function () {
        return this._template.templateRef;
    };
    var NgxInputForComponent_1;
    NgxInputForComponent.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Injector }
    ]; };
    __decorate([
        Input()
    ], NgxInputForComponent.prototype, "dataItems", void 0);
    __decorate([
        Output()
    ], NgxInputForComponent.prototype, "blurEvent", void 0);
    __decorate([
        Input()
    ], NgxInputForComponent.prototype, "field", void 0);
    __decorate([
        ViewChild(NgModel, { static: false })
    ], NgxInputForComponent.prototype, "ngModel", void 0);
    __decorate([
        ViewChild(FormControlName, { static: false })
    ], NgxInputForComponent.prototype, "formControlName", void 0);
    __decorate([
        HostBinding('class.ngx-input')
    ], NgxInputForComponent.prototype, "ngxInput", void 0);
    __decorate([
        HostListener('focusout')
    ], NgxInputForComponent.prototype, "onFocusout", null);
    __decorate([
        ContentChildren(NgxCustomTemplateForDirective, { descendants: false })
    ], NgxInputForComponent.prototype, "templates", null);
    NgxInputForComponent = NgxInputForComponent_1 = __decorate([
        Component({
            // tslint:disable-next-line:component-selector
            selector: 'ngx-input-for',
            template: "<ng-container [ngSwitch]=\"dataType\">\n    <ng-container *ngIf=\"!_template; else template\">\n        <a\n            [href]=\"value\"\n            *ngSwitchCase=\"DataTypeEnum.Url\"\n            class=\"ngx-input-child-url\"\n            [id]=\"field\">\n            {{name | translate}}\n        </a>\n        <input\n            type=\"password\"\n            *ngSwitchCase=\"DataTypeEnum.Password\"\n            [placeholder]=\"placeHolder | translate\"\n            [(ngModel)]=\"value\"\n            [id]=\"field\"\n            autocomplete=\"{{autocomplete}}\"\n            [disabled]=\"this.disabled\"\n            class=\"ngx-input-child\"\n            [readOnly]=\"readonly\">\n        <img\n            *ngSwitchCase=\"DataTypeEnum.ImageUrl\"\n            [src]=\"value\"\n            class=\"ngx-input-child-image\"\n            [id]=\"field\">\n        <input\n            type=\"file\"\n            *ngSwitchCase=\"DataTypeEnum.Upload\"\n            [placeholder]=\"placeHolder | translate\"\n            [(ngModel)]=\"value\"\n            [id]=\"field\"\n            autocomplete=\"{{autocomplete}}\"\n            [disabled]=\"this.disabled\"\n            class=\"ngx-input-child-upload\"\n            [readOnly]=\"readonly\">\n        <textarea\n            *ngSwitchCase=\"DataTypeEnum.MultilineText\"\n            [placeholder]=\"placeHolder | translate\"\n            [(ngModel)]=\"value\"\n            [id]=\"field\"\n            [disabled]=\"this.disabled\"\n            class=\"ngx-input-child-textarea\"\n            rows=\"5\"\n            [readOnly]=\"readonly\"></textarea>\n        <input\n            *ngSwitchDefault\n            type=\"text\"\n            [placeholder]=\"placeHolder | translate\"\n            [(ngModel)]=\"value\"\n            autocomplete=\"{{autocomplete}}\"\n            [id]=\"field\"\n            [disabled]=\"this.disabled\"\n            class=\"ngx-input-child\"\n            [readOnly]=\"readonly\"\n            [name]=\"field\">\n    </ng-container>\n    <ng-template #template>\n        <ng-container\n            [ngTemplateOutlet]=\"getTemplate()\"\n            [ngTemplateOutletContext]=\"{$implicit: model}\">\n        </ng-container>\n    </ng-template>\n</ng-container>\n",
            providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(function () { return NgxInputForComponent_1; }), multi: true },
                { provide: NG_VALIDATORS, useExisting: NgxInputForComponent_1, multi: true }
            ]
        })
    ], NgxInputForComponent);
    return NgxInputForComponent;
}(ElementBase));

var NgxLabelForComponent = /** @class */ (function () {
    function NgxLabelForComponent() {
        this.ngxLabel = true;
        this.reflectValue = '';
    }
    NgxLabelForComponent.prototype.ngOnInit = function () {
        try {
            this.reflectValue = getDecorators(this.model, this.field).find(function (x) { return x.key === 'Name'; }).value;
        }
        catch (_a) {
            this.reflectValue = this.field;
        }
    };
    __decorate([
        Input()
    ], NgxLabelForComponent.prototype, "model", void 0);
    __decorate([
        Input()
    ], NgxLabelForComponent.prototype, "field", void 0);
    __decorate([
        HostBinding('class.ngx-label')
    ], NgxLabelForComponent.prototype, "ngxLabel", void 0);
    NgxLabelForComponent = __decorate([
        Component({
            // tslint:disable-next-line:component-selector
            selector: 'ngx-label-for',
            template: "<label\r\n    for=\"{{field}}\"\r\n    class=\"ngx-label-child\">\r\n    {{reflectValue | translate}}\r\n</label>\r\n"
        })
    ], NgxLabelForComponent);
    return NgxLabelForComponent;
}());

var NgxValidatorForComponent = /** @class */ (function () {
    function NgxValidatorForComponent() {
        this.messages = [];
        this.ngxLabel = true;
    }
    Object.defineProperty(NgxValidatorForComponent.prototype, "errors", {
        set: function (value) {
            var e_1, _a;
            this.messages = [];
            if (value) {
                try {
                    for (var _b = __values(Object.keys(value)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var item = _c.value;
                        this.messages.push(value[item].toString());
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        HostBinding('class.ngx-validator')
    ], NgxValidatorForComponent.prototype, "ngxLabel", void 0);
    __decorate([
        Input('errors')
    ], NgxValidatorForComponent.prototype, "errors", null);
    NgxValidatorForComponent = __decorate([
        Component({
            // tslint:disable-next-line:component-selector
            selector: 'ngx-validator-for',
            template: "<div class=\"ngx-validator-child\">\n    <div *ngFor=\"let message of messages\">\n        <ng-container *ngIf=\"message\">{{message | translate}}</ng-container>\n    </div>\n</div>\n"
        })
    ], NgxValidatorForComponent);
    return NgxValidatorForComponent;
}());

var NgxValidatorDirective = /** @class */ (function () {
    function NgxValidatorDirective(el) {
        this.el = el;
        this.validator = validateControl;
    }
    NgxValidatorDirective_1 = NgxValidatorDirective;
    Object.defineProperty(NgxValidatorDirective.prototype, "sk", {
        set: function (value) {
            this.dataModel = value;
        },
        enumerable: true,
        configurable: true
    });
    NgxValidatorDirective.prototype.validate = function (control) {
        return this.validator(control, this.dataModel);
    };
    var NgxValidatorDirective_1;
    NgxValidatorDirective.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    __decorate([
        Input()
    ], NgxValidatorDirective.prototype, "field", void 0);
    __decorate([
        Input('ngx-validator')
    ], NgxValidatorDirective.prototype, "sk", null);
    NgxValidatorDirective = NgxValidatorDirective_1 = __decorate([
        Directive({
            // tslint:disable-next-line:directive-selector
            selector: '[ngx-validator][ngModel],[ngx-validator][formControl],[ngx-validator][formControlName]',
            providers: [
                { provide: NG_VALIDATORS, useExisting: NgxValidatorDirective_1, multi: true }
            ]
        })
    ], NgxValidatorDirective);
    return NgxValidatorDirective;
}());

var NgxValidatorModule = /** @class */ (function () {
    function NgxValidatorModule() {
    }
    NgxValidatorModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                FormsModule,
                ReactiveFormsModule,
                TranslateModule
            ],
            declarations: [
                NgxValidatorDirective,
                NgxValidatorForComponent,
                NgxLabelForComponent,
                NgxInputForComponent,
                NgxFormForReactiveComponent,
                NgxFormForComponent,
                NgxDropdownForComponent,
                NgxCustomTemplateForDirective
            ],
            exports: [
                NgxValidatorDirective,
                NgxValidatorForComponent,
                NgxLabelForComponent,
                NgxInputForComponent,
                NgxFormForReactiveComponent,
                NgxFormForComponent,
                NgxDropdownForComponent,
                NgxCustomTemplateForDirective
            ]
        })
    ], NgxValidatorModule);
    return NgxValidatorModule;
}());

/*
 * Public API Surface of ngx-validator
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxDropdownForComponent, NgxFormForComponent, NgxFormForReactiveComponent, NgxInputForComponent, NgxLabelForComponent, NgxValidatorDirective, NgxValidatorForComponent, NgxValidatorModule, NgxValidatorService, ElementBase as ɵa, ValueAccessorBase as ɵb, NgxCustomTemplateForDirective as ɵc };
//# sourceMappingURL=ngx-validator.js.map
